<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 23B.60 và Task 44.30 test</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <style>
        .picture-cover {
            background-image: url("img/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>

</head>

<body onload="onPageLoading()">
    <div class="container-fluid picture-cover">

    </div>
    <div class="container">
        <div class="row">
            <div class="col-sm-5">
                <div class="row">
                    <div class="col-sm-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-4">
                        <label>Username</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-username" placeholder="Nhập username..">
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-4">
                        <label>Fistname</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-firstname" placeholder="Nhập firstname..">
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-4">
                        <label>Lastname</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-lastname" placeholder="Nhập lastname..">
                    </div>
                </div>
            </div>
            <div class="col-sm-4 text-center">
                <div class="row">
                    <div class="col-sm-12">
                        <button class="btn btn-success" onclick="onBtnThrowDiceClick()">Ném throw dice</button>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12">
                        <img src="./img/dice.png" width="30%" id="dice-img">
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12">
                        <p id="throw-dice-msg" style="display: none">Chúc mừng bạn hayc chơi tiếp</p>
                    </div>
                </div>
            </div>
            <div class="col-sm-3 text-center">
                <div class="row">
                    <div class="col-sm-12">
                        <p>Voucher</p>
                        <p id="voucher-id" style="display: none">ID2210</p>
                        <p id="phan-tram-giam-gia" style="display: none">20%</p>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12 text-center">
                        <img src="./img/xe-may.jpg" width="50%" id="prize-image" style="display: none">
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12 text-center">
                <button class="btn btn-success" onclick="onBtnPrizeHistoryClick()">Dice history</button>
                <button class="btn btn-primary" onclick="onBtnVoucherHistoryClick()">Voucher history</button>
                <button class="btn btn-primary" onclick="onBtnPrizeHistoryClick()">Present history</button>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <table width="100%" class="table-bordered table-striped table-hover" id="history-placeholder-table">
                    <thead id="table-dice-history-head">
                        <tr>
                            <td>Lượt</td>
                            <td>Dice</td>
                        </tr>
                    </thead>
                    <tbody id="table-dice-history-body">
                        <tr>
                            <td>1</td>
                            <td>2</td>
                        </tr>
                        <tr>
                            <td>2</td>
                            <td>6</td>
                        </tr>
                        <tr>
                            <td>3</td>
                            <td>4</td>
                        </tr>
                        <tr>
                            <td>4</td>
                            <td>5</td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    //REGION 1: khai báo các hằng số và biến toàn cục
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    //base url
    const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gEND_OF_ROW_COL = -1;
    //REGION 2:

    //REGION 3: các hàm xử lý sự kiện
    function onPageLoading() {
        document.getElementById("history-placeholder-table").style.display = "none";
    }
    //hàm xử lý nút ném xúc xắc
    function onBtnThrowDiceClick() {
        //khai báo biến userObj
        var vUserObj = {
            username: "",
            firstname: "",
            lastname: ""
        };
        //b1: thu thập dữ liệu
        dataRead(vUserObj);
        //b2: kiểm tra dữ liệu
        var vThongTinHopLe = dataValidate(vUserObj);
        if (vThongTinHopLe) {
            var vXmlHttpDice = new XMLHttpRequest();
            //b3: gọi API trả kết quả ném xúc xắc
            goiAPI(vUserObj, vXmlHttpDice);
            //b4: hiển thị kết quả
            vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                    showDice(vXmlHttpDice);
                }
            }

        }
    }

    //hàm xử lý nút dice history
    function onBtnPrizeHistoryClick() {
        //b1: kiểm tra dữ liệu
        //khai báo biến userObj
        var vUserObj = {
            username: "",
            firstname: "",
            lastname: ""
        };
        //b2: validate dữ liệu
        dataRead(vUserObj);
        var vThongTinHopLe = dataValidate(vUserObj);
        if (vThongTinHopLe) {
            var vXmlHttpDiceHistory = new XMLHttpRequest();
            //b3: gọi API
            goiApiLayLichSuDice(vUserObj, vXmlHttpDiceHistory);
            //b4: hiển thị
            vXmlHttpDiceHistory.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        showDiceHistory(vXmlHttpDiceHistory);
                    }
                }
        }

    }

    //REGION 4: các hàm dùng chung
    //hàm thu thập dữ liệu
    function dataRead(paramUserObj) {
        //truy xuất phần tử input theo id
        var vUserNameInp = document.getElementById("inp-username");
        var vFirstNameInp = document.getElementById("inp-firstname");
        var vLastNameInp = document.getElementById("inp-lastname");
        //gán cho object
        paramUserObj.username = vUserNameInp.value.trim();
        paramUserObj.firstname = vFirstNameInp.value.trim();
        paramUserObj.lastname = vLastNameInp.value.trim();
    }
    //hàm kiểm tra dữ liệu

    function dataValidate(paramDataUser) {
        if (paramDataUser.username == "") {
            alert("Cần nhập username");
            return false;
        }
        if (paramDataUser.firstname == "") {
            alert("Cần nhập firstname");
            return false;
        }
        if (paramDataUser.lastname == "") {
            alert("Cần nhập lastname");
            return false;
        }
        return true;
    }
    //hàm gọi API kết quả ném xúc xắc
    function goiAPI(paramUserObj, paramXmlHttp) {
        paramXmlHttp.open("POST", vBASE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send(JSON.stringify(paramUserObj));  //chuyển Json object sang string
    }
    //hàm gọi API lấy lịch sử Dice
    function goiApiLayLichSuDice(paramUserObj, paramXmlHttp) {
        paramXmlHttp.open("GET", vBASE_URL + "/dice-history?username=" + paramUserObj.username, true);
        paramXmlHttp.send();
    }

    //hàm hiển thị xúc xắc
    function showDice(paramXmlHttp) {
        console.log(paramXmlHttp.responseText);
        // parsing to object
        var vResponse = JSON.parse(paramXmlHttp.responseText);
        // get result dice
        var vDiceReady = vResponse.dice;
        console.log("dice result:= " + vDiceReady);
        var vThrowDiceMsg = document.getElementById("throw-dice-msg");
        var vThrowDiceImg = document.getElementById("dice-img");
        //đổi lời nhắn
        if (vDiceReady > 3) {
            vThrowDiceMsg.innerHTML = "Chúc mừng bạn hãy chơi tiếp lần nữa!";
            vThrowDiceMsg.style.display = "block";
        }
        else {
            vThrowDiceMsg.innerHTML = "Chúc bạn may mắn hơn lần sau!";
            vThrowDiceMsg.style.display = "block";
        }
        //đổi hình ảnh theo dice result
        if (vDiceReady == 1) { vThrowDiceImg.src = "./img/1.png"; };
        if (vDiceReady == 2) { vThrowDiceImg.src = "./img/2.png"; };
        if (vDiceReady == 3) { vThrowDiceImg.src = "./img/3.png"; };
        if (vDiceReady == 4) { vThrowDiceImg.src = "./img/4.png"; };
        if (vDiceReady == 5) { vThrowDiceImg.src = "./img/5.png"; };
        if (vDiceReady == 6) { vThrowDiceImg.src = "./img/6.png"; };
        // get voucher result
        var vVoucherReady = vResponse.voucher;
        var vVoucherId = document.getElementById("voucher-id");
        var vPhanTramGiamGia = document.getElementById("phan-tram-giam-gia");
        if (vVoucherReady !== null) {
            vVoucherId.innerHTML = vVoucherReady.id;
            vVoucherId.style.display = "block";
            vPhanTramGiamGia.innerHTML = vVoucherReady.phanTramGiamGia + "%";
            vPhanTramGiamGia.style.display = "block";
        }
        else {
            vVoucherId.innerHTML = "Không có voucher";
            vVoucherId.style.display = "block";
        }
        //get present result
        var vPrizeReady = vResponse.prize;
        var vPrizeImg = document.getElementById("prize-image");
        if (vPrizeReady == null) {
            vPrizeImg.src = "./img/no-present.jpg";
            vPrizeImg.style.display = "block";
        }
        else if (vPrizeReady == "Sổ") {
            vPrizeImg.src = "./img/book.jpg";
            vPrizeImg.style.display = "block";
        }
        else if (vPrizeReady == "Áo mưa") {
            vPrizeImg.src = "./img/ao-mua.jpg";
            vPrizeImg.style.display = "block";
        }
        else if (vPrizeReady == "Xe đạp") {
            vPrizeImg.src = "./img/bike.jpg";
            vPrizeImg.style.display = "block";
        }
        else if (vPrizeReady == "Bút") {
            vPrizeImg.src = "./img/but.jpg";
            vPrizeImg.style.display = "block";
        }
        else if (vPrizeReady == "Ô tô") {
            vPrizeImg.src = "./img/car.jpg";
            vPrizeImg.style.display = "block";
        }
        else if (vPrizeReady == "Mũ") {
            vPrizeImg.src = "./img/hat.jpg";
            vPrizeImg.style.display = "block";
        }
        else if (vPrizeReady == "Áo phông") {
            vPrizeImg.src = "./img/t-shirt.jpg";
            vPrizeImg.style.display = "block";
        }
        else if (vPrizeReady == "Xe máy") {
            vPrizeImg.src = "./img/xe-may.jpg";
            vPrizeImg.style.display = "block";
        }
    }
    function showDiceHistory(paramXmlHttp) {
        console.log(paramXmlHttp.responseText);
        document.getElementById("history-placeholder-table").style.display = "block";
        var vDiceHistoryObj = JSON.parse(paramXmlHttp.responseText);
        var vHistoryTable = document.getElementById("history-placeholder-table");
        var vTableHead = document.getElementById("table-dice-history-head");
        var vTableBody = vHistoryTable.getElementsByTagName("tbody")[0];
        //xóa bảng
        vTableHead.innerHTML = "";
        vTableBody.innerHTML = "";
        //thêm header
        var vNewHeaderRow = vTableHead.insertRow(gEND_OF_ROW_COL);
        var vGameHeaderCell = vNewHeaderRow.insertCell(0);
        var vDiceHeaderCell = vNewHeaderRow.insertCell(1);
        //điền dữ liệu cho header
        vGameHeaderCell.innerHTML = "Lượt";
        vDiceHeaderCell.innerHTML = "Dice";

        for (var bI = 0; bI < vDiceHistoryObj.dices.length; bI++) {
            //thêm 1 dòng mới và gắn vào table
            var bNewRow = vTableBody.insertRow(gEND_OF_ROW_COL);
            //thêm 2 ô trên dòng
            var bGameCell = bNewRow.insertCell(0);
            var bDiceCell = bNewRow.insertCell(1);
            //điền dữ liệu cho từng ô
            bGameCell.innerHTML = bI + 1;
            bDiceCell.innerHTML = vDiceHistoryObj.dices[bI];
        }
    }
</script>

</html>